# This file is a template, and might need editing before it works on your project.
# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
#
# You can copy and paste this template into a new `.gitlab-ci.yml` file.
# You should not add this template to an existing `.gitlab-ci.yml` file by using the `include:` keyword.
#
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

stages:
  - test
  - deploy

test-job:
  stage: test
  environment: production
  only:
    - merge_requests
  image:
    name: "bbtv/snowsql"
  before_script:
    - apt-get update -y && apt-get install git -y
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."
    - git fetch origin $CI_MERGE_REQUEST_TARGET_BRANCH_NAME:$CI_MERGE_REQUEST_TARGET_BRANCH_NAME
    - git checkout $CI_MERGE_REQUEST_TARGET_BRANCH_NAME
    - echo "Affected files:"
    - CHANGED_FILES=$(git diff --name-only $CI_COMMIT_SHA...$CI_MERGE_REQUEST_SOURCE_BRANCH_SHA)
    - echo $CHANGED_FILES
    - echo $CI_COMMIT_SHA
    - echo $CI_MERGE_REQUEST_SOURCE_BRANCH_SHA
    - git log
    - git diff --name-only --diff-filter=A $CI_MERGE_REQUEST_SOURCE_BRANCH_SHA...$CI_COMMIT_SHA
    - git diff --name-only --diff-filter=A $CI_COMMIT_SHA...$CI_MERGE_REQUEST_SOURCE_BRANCH_SHA | grep '\.sql$' | xargs -I {} snowsql --filename {}


deploy-job:
  stage: deploy
  environment: production
  only:
    - master
  except:
    - merge_requests
  image:
    name: "bbtv/snowsql"
  before_script:
    - apt-get update -y && apt-get install git -y
  script:
    - echo "Deploying application..."
    - echo "Application successfully deployed."
    - echo "Affected files:"
    - git diff --name-only --diff-filter=A $CI_COMMIT_BEFORE_SHA..$CI_COMMIT_SHA | grep '\.sql$' | xargs -I {} echo {}
    - git diff --name-only --diff-filter=A $CI_COMMIT_BEFORE_SHA..$CI_COMMIT_SHA | grep '\.sql$' | xargs -I {} snowsql --filename {}
